class CacheHelper {
    constructor() {
        this.store = {};
        this.add = (key, value) => {
            this.store[key] = value;
            return value;
        };
        this.remove = (key) => Reflect.deleteProperty(this.store, key);
        this.clear = () => (this.store = {});
        this.get = async (key, cb) => {
            if (!this.store[key])
                this.store[key] = await cb();
            return this.store[key];
        };
    }
}
export default CacheHelper;
