const addCacheWrapper = (func) => {
    if (typeof func !== "function")
        throw new Error("param error ,need function!");
    const cache = {};
    return function (...rest) {
        const key = JSON.stringify(rest);
        if (cache[key])
            return cache[key];
        cache[key] = func(...rest);
        return cache[key];
    };
};
export const genSetRefObjFunc = (obj) => {
    return (key, value) => {
        if (typeof key === "string") {
            if (typeof value === "undefined")
                Reflect.deleteProperty(obj.current, key);
            else
                obj.current = Object.assign(Object.assign({}, obj.current), { [key]: value });
        }
        else if (typeof key === "function")
            obj.current = key(obj.current);
        else
            obj.current = Object.assign(Object.assign({}, obj.current), key);
    };
};
export const genSetObjFunc = (obj) => {
    return (key, value) => {
        if (typeof key === "string") {
            if (typeof value === "undefined")
                Reflect.deleteProperty(obj, key);
            else
                obj[key] = value;
        }
        else if (typeof key === "function")
            key(obj);
        else
            Object.entries(key).map(([k, v]) => (obj[k] = v));
    };
};
export const parseJson = (json) => {
    let res = null;
    if (!json)
        return res;
    try {
        res = JSON.parse(json);
    }
    catch (e) {
        console.error(e);
    }
    return res;
};
export const getDom = (id, className) => {
    let dom = document.querySelector(`#${id}`);
    if (!dom) {
        dom = document.createElement("div");
        dom.id = id;
        document.body.appendChild(dom);
    }
    className && dom.classList.add(className);
    return dom;
};
export default { addCacheWrapper, genSetRefObjFunc, genSetObjFunc, parseJson, getDom };
